.Dd 2016-06-12
.Dt NCI 1
.Os
.Sh NAME
.Nm nci
.Nd Interact with Canvas installations
.Sh DESCRIPTION
The
.Nm
suite allows interaction with Canvas installations.
.Sh FILES
All
.Nm
programs need to know the url of the Canvas installation they will
connect to, and authentication to perform actions as the proper
user. For this, two files are used.
.Pp
.Bl -tag -width Ds
.It ${XDG_CONFIG_HOME}/nci/site
This text file should contain exactly one line, which will be treated
as a base url. This should be something like

.Dl https://someuniversity.instructure.com
.It ${XDG_CONFIG_HOME}/nci/token
This text file should contain exactly one line, which will be read as
an access token. For details, see
.Sx ACCESS TOKENS .
.El
.Sh ACCESS TOKENS
Third party programs
.Po like
.Nm
.Pc
authenticate themselves to Canvas by means of
.Ql Access Tokens .
The standard way for an application to acquire an access token is to
register with Instructure and perform the OAuth2 dance. This, however,
is a huge pain in the neck, and it is not entirely clear that all
Canvas-using entities have set up OAuth2. Therefore,
.Nm
uses another method: manual user generation of access tokens. In a web
browser, while logged into Canvas, go to
.Pp
.D1 Account > Settings > New Access Token
.Pp
and follow the directions to create an access token. It is recommended
that you set an expiration date for the token. Write the generated
token to ${XDG_CONFIG_HOME}/nci/token. This token should be treated
as a password: if a malicious entity acquires the token, they will be
able perform actions with your credentials on Canvas.
.Pp
.Sh SEE ALSO
.Xr nci-course-settings 1
.Xr nci-create-assignment 1
.Xr nci-create-assignment-group 1
.Xr nci-delete-assignment 1
.Xr nci-delete-assignment-group 1
.Xr nci-edit-assignment 1
.Xr nci-edit-assignment-group 1
.Xr nci-get-assignment-grades 1
.Xr nci-list-assignments 1
.Xr nci-list-files 1
.Xr nci-list-courses 1
.Xr nci-put-assignment-grades 1
.Xr nci-put-file 1
.Sh AUTHORS
.An S. Gilles Aq Mt sgilles@math.umd.edu
